;=====================================================
;create map index save file for savegame
;=====================================================
SAVE_SAVED_MAP_STATE:	;ebx = file handle

mov edx,[esp+1E4h]	;REPLACED CODE (7 bytes)
			;edx = pointer to SAVEGAME.xxx filename + path
push ebx
push ecx
push esi
push edi
xor ebx,ebx

	mov esi,edx
	mov edi,SAVEGAMENAME_BUFFER
	call TransferString
;=====================================================
mov DWORD [edi-8],'DMAP'	;'SAVEGAME' replaced by 'SAVEDMAP'

invoke DeleteFile,SAVEGAMENAME_BUFFER	;delete "SAVEDMAP.xxx" if existing

cmp [currentbitmap],0
    jz NO_MAP_SAVE_1

invoke CreateFile,SAVEGAMENAME_BUFFER,GENERIC_WRITE,0,0,\
		CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	test eax,eax
	     jz SAVED_FILE_LOAD_FAIL2
	cmp eax,-1
	    jz SAVED_FILE_LOAD_FAIL2
	mov ebx,eax

invoke SetFilePointer,eax,0,0,FILE_BEGIN
	cmp eax,-1
	    jz SAVED_FILE_LOAD_FAIL2

	sub esp,4
	mov eax,esp		;write POSITION values
invoke WriteFile,ebx,CURRENT_MAP_VALUES,16,eax,0
	test eax,eax
	pop ecx
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,16
	    jnz SAVED_FILE_LOAD_FAIL2

	xor al,al
	mov edi,CURRENT_MAP_BUFFER
	or ecx,0FFFFFFFFh
	repnz scasb			;get BMP name size
	sub edi,CURRENT_MAP_BUFFER	;in edi

	sub esp,4
	mov eax,esp
invoke WriteFile,ebx,CURRENT_MAP_BUFFER,edi,eax,0    ;write BITMAP NAME
	add esp,4	;no point in error-checking here

SAVED_FILE_LOAD_FAIL2:
	test ebx,ebx
	     jz NoCloseHandle_SAVELOAD2
	invoke CloseHandle,ebx
	NoCloseHandle_SAVELOAD2:

NO_MAP_SAVE_1:
pop edi
pop esi
pop ecx
pop ebx

mov edx,[esp+1E4h]	;restore edx
ret